/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: freeparm.c,v 1.8 2008/09/18 05:47:18 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <babolo/BLINflag.h>
#include "parser.h"

#ifdef __amd64__
#define PTOFI (u_int32_t)(u_int64_t)
#else
#define PTOFI (u_int32_t)
#endif

void
babolo_freeparm(babolo_parm *parm) {
    u_int32_t flag;

    if  (parm) {
        flag = parm->flag;
        ifBLIN_QV4(flag) fprintf( stderr
                                      , "+babolo_freeparm flag=%08X argc=%d argv=%08X\n"
                                      , parm->flag
                                      , parm->argc
                                      , PTOFI parm->argv
                                      );
        if  (  ((~parm->flag) & (Bpars_NOEN | Bpars_NOAL))
            && (parm->argc > 0)
            && *parm->argv
            ) free(*parm->argv);
        free(parm);
        ifBLIN_QV4(flag) fprintf(stderr, "-babolo_freeparm\n");
}   }
